Section Group.

Parameter G : Set.
Parameter op : G -> G -> G.
Parameter e : G.

Infix "o" := op (at level 35, right associativity).
Axiom assoc : forall a b c : G, a o (b o c) = (a o b) o c.
Axiom unit_l : forall a : G, e o a = a.
Axiom unit_r : forall a : G, a o e = a.
Axiom inv : forall a : G, exists b : G, b o a = e /\ a o b = e.

Lemma inv_l : forall a : G, exists b : G, b o a = e.
Proof.
intro.
assert (exists b : G, b o a = e /\ a o b = e).
apply (inv a).
elim H.
intro.
intro.
assert (x o a = e).
apply H0.
exists x.
assumption.
Qed.

Lemma inv_r : forall a : G, exists b : G, a o b = e.
Proof.
intro.
assert (exists b : G, b o a = e /\ a o b = e).
apply (inv a).
elim H.
intro.
intro.
assert (a o x = e).
apply H0.
exists x.
assumption.
Qed.

Lemma cancel_r :
  forall a b c : G, a o b = a o c -> b = c.
Proof.
intros.
rewrite <- unit_l.
rewrite <- unit_l with b.
elim (inv_l a).
intros.
rewrite <- H0.
rewrite <- assoc.
rewrite <- assoc.
rewrite H.
reflexivity.
Qed.

Lemma unique_inv_alt :
  forall a b c : G, a o b = e -> c o a = e -> b = c.
Proof.
intros.
rewrite <- unit_l with b.
rewrite <- H0.
rewrite <- assoc.
rewrite H.
apply unit_r.
Qed.

Lemma unique_inv :
  forall a b c : G, a o b = e /\ c o a = e -> b = c.
Proof.
intros.
assert (a o b = e).
apply H.
assert (c o a = e).
apply H.
rewrite <- unit_l with b.
rewrite <- H1.
rewrite <- assoc.
rewrite H0.
apply unit_r.
Qed.

End Group.
